package com.fr.plugin.xxxxx.factory.resolver;

import com.fr.json.JSONObject;
import com.fr.plugin.xxxxx.factory.util.DataUtil;
import com.fr.stable.StringUtils;
import com.jayway.jsonpath.JsonPath;
import com.tptj.plugin.hg.impl.AbstractResolver;
import com.tptj.plugin.hg.stable.SimpleDataModel;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * @Author fr.open
 * @Date 2020/11/26
 * @Description
 **/
public class JsonPathResolver extends AbstractResolver {

    @Override
    public SimpleDataModel parse(Object data, String others) {
        SimpleDataModel dataModel = new SimpleDataModel();
        String query = others;
        JSONObject param = null;
        if(others.startsWith("{")){
            param = new JSONObject(others);
            query = param.getString("query");

        }
        Object res = JsonPath.read(data.toString(), query);
        List<Object[]> datas = new ArrayList<>();
        List<String> columns = new ArrayList<>();
        if (res instanceof List) {
            List<Map> list = (List<Map>) res;
            for (Map map : list) {
                if (map.keySet().size() > columns.size()) {
                    columns = new ArrayList(map.keySet());
                }
            }
            for (Map map : list) {
                Object[] row = new Object[columns.size()];
                for (int i = 0; i < columns.size(); i++) {
                    row[i] = map.get(columns.get(i));
                }
                datas.add(row);
            }

        } else if (res instanceof Map) {
            Map map = (Map) res;
            columns = new ArrayList(map.keySet());
            Object[] row = new Object[columns.size()];
            for (int i = 0; i < columns.size(); i++) {
                row[i] = map.get(columns.get(i));
            }
            datas.add(row);
        } else {
            columns.add("data");
            datas.add(new Object[]{res});
        }
        dataModel.setDatas(datas);
        if(param != null){
            dataModel.setCols(DataUtil.translate(columns, param.getBoolean("translate")));
            return DataUtil.sort(dataModel,param == null? StringUtils.EMPTY:param.getString("sort"));
        }else {
            dataModel.setCols(columns);
        }
        return dataModel;
    }

    @Override
    public String getName() {
        return "JPath解析";
    }

    @Override
    public String getDefaultConfig() {
        return "{\n" +
                "\"query\":\"$\",\n" +
                "\"sort\":\"\",\n" +
                "\"translate\":\"false\",\n" +
                "}";
    }

}
